VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   BackColor       =   &H8000000A&
   Caption         =   "Trisection and trilateration simulator, 2006"
   ClientHeight    =   9495
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   13200
   LinkTopic       =   "Form1"
   ScaleHeight     =   9495
   ScaleWidth      =   13200
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00E0E0E0&
      Height          =   6135
      Left            =   120
      ScaleHeight     =   405
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   389
      TabIndex        =   0
      Top             =   120
      Width           =   5895
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   10440
      Top             =   480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu File 
      Caption         =   "File"
      Begin VB.Menu Simulate 
         Caption         =   "Simulate"
      End
      Begin VB.Menu Exit_Program 
         Caption         =   "Exit Program"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Exit_Program_Click()
End
End Sub

Private Sub Form_Load()
Form1.Picture1.Height = Form1.Height
Form1.Picture1.Width = Form1.Picture1.Height
End Sub

Private Sub Simulate_Click()

Randomize

Dim StopBit As Long, NumOfLSAITe As Long, k As Long
Dim Plotpoints As Boolean
Dim StdevX As Double, StdevY As Double
Dim Xerr As Double, Yerr As Double
Dim XerrSum As Double, YerrSum As Double, XYErrsum As Double
Dim SigmaNUllSum As Double, SigmaYsum As Double, sigmaXsum As Double
Dim XerrSum2 As Double, YerrSum2 As Double
Dim Nvalid As Long

Plotpoints = True
Call DrawLines(Plotpoints)
Call Open_Input_Parameters
Call AssignTaus
Call CreateP0

Rem Start of simulation with given constellation
Call PrintOutputForSimu


For k = 1 To InputParam.NumberOfSimulations
 Call CreatePointsPAandTrueObservations
 Call DefineObservations
 Call PerformPhotogrammetricObservations
 Call PerformFieldObservations
 Call InitialApproximation

StartOfRecalculation:
 
 NumOfLSAITe = 0
 StopBit = CONTINUE
 Do Until (StopBit = FINISH Or NumOfLSAITe = 7)
  NumOfLSAITe = NumOfLSAITe + 1
  Call CreateMatricesAndVectorsForLSA
  Call SolveLSAInMatlab(StopBit)
 Loop
 Rem Check if any observation has Baarda's test value in baarda() above critical in tau()
 Rem We can only use this test for redundancy of 2 and above
 Dim BaardaAffected As Boolean
 
 BaardaAffected = False
 
 GoTo OMitBaarda
 If (NumOfObservations - 2) > 1 Then
  For i = 1 To InputParam.NPA
  
   If Obs(i).ISdist = True And Obs(i).idDist = MaxBaardaIndex Then
    If Abs(Baarda(MaxBaardaIndex)) > tau(NumOfObservations - 2) Then
     Obs(i).ISdist = False
     BaardaAffected = True
     fff = Obs(i).EpsilonDist
    End If
   End If
   If Obs(i).ISazim = True And Obs(i).idAzim = MaxBaardaIndex Then
    If Abs(Baarda(MaxBaardaIndex)) > tau(NumOfObservations - 2) Then
     Obs(i).ISazim = False
     BaardaAffected = True
     fff = Obs(i).EpsilonAzim
    End If
   End If
  Next i
 End If
 
If BaardaAffected = True Then
   StopBit = RECALCULATE
   GoTo StartOfRecalculation
End If


OMitBaarda:

Call DrawObs(Plotpoints)
Call PrintOutputPerIte(k)
 
Rem Here we compute mean and standard deviation variables
Xerr = P0.TruePos.x - P0.InitialPos.x
Yerr = P0.TruePos.y - P0.InitialPos.y
If Abs(Xerr) < 3 And Abs(Yerr < 3) Then
 Nvalid = Nvalid + 1
 XerrSum = XerrSum + Xerr
 XerrSum2 = XerrSum2 + Xerr ^ 2
 YerrSum = YerrSum + Yerr
 YerrSum2 = YerrSum2 + Yerr ^ 2
 XYErrsum = XYErrsum + Sqr(Xerr ^ 2 + Yerr ^ 2)
 SigmaNUllSum = SigmaNUllSum + sigmaNull
 sigmaXsum = sigmaXsum + sigmaX
 SigmaYsum = SigmaYsum + sigmaY
End If


Next k

AddVAl = 200
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 280 + AddVAl
Form1.Picture1.Print "Mean(dXdY): " & Format$(XYErrsum / Nvalid, "0.00")

Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 300 + AddVAl
Form1.Picture1.Print "Mean(dX): " & Format$(XerrSum / Nvalid, "0.00")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 320 + AddVAl
Form1.Picture1.Print "Mean(dY): " & Format$(YerrSum / Nvalid, "0.00")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 340 + AddVAl
Form1.Picture1.Print "SD(dX): " & Format$(Sqr(XerrSum2 / (Nvalid - 1)), "0.000")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 360 + AddVAl
Form1.Picture1.Print "SD(dY): " & Format$(Sqr(YerrSum2 / (Nvalid - 1)), "0.000")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 380 + AddVAl
Form1.Picture1.Print "Valid(%): " & Format$(100 * (Nvalid / InputParam.NumberOfSimulations), "0.0")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 400 + AddVAl
Form1.Picture1.Print "mean(sigmaNull): " & Format$((SigmaNUllSum / Nvalid), "0.00")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 420 + AddVAl
Form1.Picture1.Print "mean(sigmaX): " & Format$((sigmaXsum / Nvalid), "0.000")
Form1.Picture1.CurrentX = 10
Form1.Picture1.CurrentY = 440 + AddVAl
Form1.Picture1.Print "mean(sigmaY): " & Format$((SigmaYsum / Nvalid), "0.000")

lapu = MsgBox("Simulointi valmis, simuloituja paikannuksia " & InputParam.NumberOfSimulations, , "Viesti ")

End Sub
